<html>
<head>
<title>OgreSingleton.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreSingleton.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreSingleton_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="comment">/* Original version Copyright (C) Scott Bilas, 2000.</span>
<a name="l00029"></a>00029 <span class="comment"> * All rights reserved worldwide.</span>
<a name="l00030"></a>00030 <span class="comment"> *</span>
<a name="l00031"></a>00031 <span class="comment"> * This software is provided &quot;as is&quot; without express or implied</span>
<a name="l00032"></a>00032 <span class="comment"> * warranties. You may freely copy and compile this source into</span>
<a name="l00033"></a>00033 <span class="comment"> * applications you distribute provided that the copyright text</span>
<a name="l00034"></a>00034 <span class="comment"> * below is included in the resulting source code, for example:</span>
<a name="l00035"></a>00035 <span class="comment"> * &quot;Portions Copyright (C) Scott Bilas, 2000&quot;</span>
<a name="l00036"></a>00036 <span class="comment"> */</span>
<a name="l00037"></a>00037 <span class="preprocessor">#ifndef _SINGLETON_H__</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span><span class="preprocessor">#define _SINGLETON_H__</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span>
<a name="l00040"></a>00040 <span class="comment">// Added by Steve Streeting for Ogre</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &quot;<a class="code" href="OgreHeaderPrefix_8h.html">OgreHeaderPrefix.h</a>&quot;</span>
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="preprocessor">#if OGRE_COMPILER == OGRE_COMPILER_MSVC</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span><span class="comment">// Turn off warnings generated by this singleton implementation</span>
<a name="l00046"></a>00046 <span class="preprocessor">#   pragma warning (disable : 4311)</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span><span class="preprocessor">#   pragma warning (disable : 4312)</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span>
<a name="l00050"></a>00050 <span class="preprocessor">#if defined ( OGRE_GCC_VISIBILITY )</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span><span class="preprocessor">#   pragma GCC visibility push(default)</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span><span class="keyword">namespace </span>Ogre {
<a name="l00061"></a>00061 <span class="comment">// End SJS additions</span>
<a name="l00064"></a><a class="code" href="classOgre_1_1Singleton.html">00064</a> <span class="comment"></span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>
<a name="l00065"></a>00065     {
<a name="l00066"></a>00066     <span class="keyword">private</span>:
<a name="l00068"></a>00068         <a class="code" href="classOgre_1_1Singleton.html#a2b0622a1223ac3a0c6b9c53e787b8d93">Singleton</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton&lt;T&gt;</a> &amp;);
<a name="l00069"></a>00069 
<a name="l00071"></a>00071         <a class="code" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>&amp; <a class="code" href="classOgre_1_1Singleton.html#abf050a1f67f274103c1d5b2f6c4e0381" title="Private operator= .">operator=</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton&lt;T&gt;</a> &amp;);
<a name="l00072"></a>00072     
<a name="l00073"></a>00073     <span class="keyword">protected</span>:
<a name="l00074"></a>00074 
<a name="l00075"></a><a class="code" href="classOgre_1_1Singleton.html#aff0baaaed91d8505cfb72b7725ae1c37">00075</a>         <span class="keyword">static</span> T* <a class="code" href="classOgre_1_1Singleton.html#aff0baaaed91d8505cfb72b7725ae1c37">msSingleton</a>;
<a name="l00076"></a>00076 
<a name="l00077"></a>00077     <span class="keyword">public</span>:
<a name="l00078"></a><a class="code" href="classOgre_1_1Singleton.html#a2b0622a1223ac3a0c6b9c53e787b8d93">00078</a>         <a class="code" href="classOgre_1_1Singleton.html#a2b0622a1223ac3a0c6b9c53e787b8d93">Singleton</a>( <span class="keywordtype">void</span> )
<a name="l00079"></a>00079         {
<a name="l00080"></a>00080             assert( !<a class="code" href="classOgre_1_1Singleton.html#aff0baaaed91d8505cfb72b7725ae1c37">msSingleton</a> );
<a name="l00081"></a>00081 <span class="preprocessor">#if defined( _MSC_VER ) &amp;&amp; _MSC_VER &lt; 1200   </span>
<a name="l00082"></a>00082 <span class="preprocessor"></span>            <span class="keywordtype">int</span> offset = (int)(T*)1 - (int)(<a class="code" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton &lt;T&gt;</a>*)(T*)1;
<a name="l00083"></a>00083             <a class="code" href="classOgre_1_1Singleton.html#aff0baaaed91d8505cfb72b7725ae1c37">msSingleton</a> = (T*)((<span class="keywordtype">int</span>)<span class="keyword">this</span> + offset);
<a name="l00084"></a>00084 <span class="preprocessor">#else</span>
<a name="l00085"></a>00085 <span class="preprocessor"></span>        <a class="code" href="classOgre_1_1Singleton.html#aff0baaaed91d8505cfb72b7725ae1c37">msSingleton</a> = <span class="keyword">static_cast&lt;</span> T* <span class="keyword">&gt;</span>( this );
<a name="l00086"></a>00086 <span class="preprocessor">#endif</span>
<a name="l00087"></a>00087 <span class="preprocessor"></span>        }
<a name="l00088"></a><a class="code" href="classOgre_1_1Singleton.html#a9bc0518bb06d12629e287149cdcc4b5d">00088</a>         <a class="code" href="classOgre_1_1Singleton.html#a9bc0518bb06d12629e287149cdcc4b5d">~Singleton</a>( <span class="keywordtype">void</span> )
<a name="l00089"></a>00089             {  assert( <a class="code" href="classOgre_1_1Singleton.html#aff0baaaed91d8505cfb72b7725ae1c37">msSingleton</a> );  <a class="code" href="classOgre_1_1Singleton.html#aff0baaaed91d8505cfb72b7725ae1c37">msSingleton</a> = 0;  }
<a name="l00090"></a><a class="code" href="classOgre_1_1Singleton.html#a7757bd7ac3702c144502e53ad6491888">00090</a>         <span class="keyword">static</span> T&amp; <a class="code" href="classOgre_1_1Singleton.html#a7757bd7ac3702c144502e53ad6491888">getSingleton</a>( <span class="keywordtype">void</span> )
<a name="l00091"></a>00091         {   assert( <a class="code" href="classOgre_1_1Singleton.html#aff0baaaed91d8505cfb72b7725ae1c37">msSingleton</a> );  <span class="keywordflow">return</span> ( *<a class="code" href="classOgre_1_1Singleton.html#aff0baaaed91d8505cfb72b7725ae1c37">msSingleton</a> ); }
<a name="l00092"></a><a class="code" href="classOgre_1_1Singleton.html#a7ab51c46521b89723d6186a52a7e0d7b">00092</a>         <span class="keyword">static</span> T* <a class="code" href="classOgre_1_1Singleton.html#a7ab51c46521b89723d6186a52a7e0d7b">getSingletonPtr</a>( <span class="keywordtype">void</span> )
<a name="l00093"></a>00093         { <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Singleton.html#aff0baaaed91d8505cfb72b7725ae1c37">msSingleton</a>; }
<a name="l00094"></a>00094     };
<a name="l00098"></a>00098 }
<a name="l00099"></a>00099 <span class="preprocessor">#if defined ( OGRE_GCC_VISIBILITY )</span>
<a name="l00100"></a>00100 <span class="preprocessor"></span><span class="preprocessor">#   pragma GCC visibility pop</span>
<a name="l00101"></a>00101 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00102"></a>00102 <span class="preprocessor"></span>
<a name="l00103"></a>00103 <span class="preprocessor">#include &quot;<a class="code" href="OgreHeaderSuffix_8h.html">OgreHeaderSuffix.h</a>&quot;</span>
<a name="l00104"></a>00104 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
